#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include "petrol.h"
#include "utils.h"


void skip(FILE *fp);

void GetInputParameters(Settings *s, Population *p)
{
  FILE *inpfl, *dafl;
  int i, n;

  if((inpfl = fopen(s->infile, "r")) == NULL)
    {
      fprintf(stderr, "unable to open input file: \t %s\n", s->infile);
      fprintf(stderr, "exiting....\n");
      exit(1);
    }
  fscanf(inpfl,"%d",&(p->popSize)); skip(inpfl);

  fscanf(inpfl,"%d",&(p->chromosomeLen)); skip(inpfl);

  fscanf(inpfl,"%d",&(p->numGenerations)); skip(inpfl);

  fscanf(inpfl,"%d",&(p->xType)); skip(inpfl);
  
  fscanf(inpfl,"%lf",&(p->probCrossover)); skip(inpfl);

  fscanf(inpfl,"%lf",&(p->probMutation)); skip(inpfl);

  fscanf(inpfl,"%s",&(s->fname)); skip(inpfl);
  
  fscanf(inpfl,"%lf", &(p->Cmult)); skip(inpfl);
  
  fscanf(inpfl,"%d", &(p->lambda)); skip(inpfl);

  fscanf(inpfl,"%s",&(p->appFilename)); skip(inpfl);

  fscanf(stdin,"%d", &(p->seed)); /* skip(inpfl); */

  fclose(inpfl);




  return;
}

void skip(FILE *fp)
{
  int ch;
  while( (ch = fgetc(fp)) != '\n')
    if(ch == EOF) 
      return;
}
