#include <stdio.h>
#include "petrol.h"
#include "utils.h"

void CopyIndividual(Individual *from, Individual *to);
void FindNBest(Individual *p, int *rank, Population *);


void ChooseBest(Settings *s, Population *p) 
{
  int *rank, *location;
  int i, popsize ;

  popsize = p->popSize;

  rank = (int *) malloc(sizeof(int) * popsize * p->lambda);
  location = (int *) malloc(sizeof(int) * popsize);

  for(i = 0; i < popsize * p->lambda; i++) {
    rank[i] = i;
  }
  for(i = 0; i < popsize; i++) {
    location[i] = i;
  }
  for( i = 0; i < popsize/2; i++) 
    IntSwap(&(location[randInt(0,popsize-1)]), 
	    &(location[randInt(0,popsize-1)]));

  
  FindNBest(p->pop, rank, p);
  
  for(i = 0; i < popsize; i++)
    CopyIndividual(&(p->pop[rank[i]]), &(p->newpop[location[i]]));

  free(rank);
  free (location);
}


void FindNBest(Individual *p, int *rank, Population *pop)
{
  int i, max, current;
  
  max = 0;

  for(current = 0; current < pop->popSize - 1  ; current++) {
    max = current;
    /* Find Next best */
    for(i = current + 1; i < (pop->popSize * pop->lambda); i++) {
      if((p + rank[i])->fitness > (p + rank[max])->fitness) {
	max = i;
      }
     }
    IntSwap(&rank[current], &rank[max]);
  }

  for(i = 0; i < pop->popSize; i++){
    if(rank[i] >= pop->popSize * pop->lambda){
      fprintf(stdout, "Bad Sort: %3i \n", rank[i]);
      exit(1);
    }
  }

}

void CopyIndividual(Individual *from, Individual *to)
{
  /* should use an overloaded assignment operator to do deep copying
     in C++ */
  int i;

  to->chromLen = from->chromLen;
  to->fitness = from->fitness;
  to->scaledFitness = from->scaledFitness;
  to->value = from->value;

  
  for(i = 0; i < to->chromLen; i++) {
    to->chrom[i] = from->chrom[i];
  }
}
