
#include <stdlib.h>

#ifdef USE_PVM
#include <pvm3.h>
#endif /* USE_PVM */

#include "petrol.h"
#include "utils.h"


void PopulationStats(Settings *s, Population *p, Individual *pop)
{
  int n;                  /* counter */
  int max, min;           /* index of best, worst */
  double sum, fitness;    /* tmp vars */

  /* should do scaling here */

  
  /* Finally, figure the total fitness of the population */
  for (n = 0, min = 0, max = 0, sum = 0.0; n < p->popSize; n++) {
    fitness = (pop + n)->fitness;
    if (fitness < (pop + min)->fitness)
      min = n;
    if (fitness > (pop + max)->fitness)
      max = n;
    
    sum += fitness;
  }
  p->sumFitness = sum;
  p->avgFitness = sum / (double) p->popSize;
  p->minFitness = min;
  p->maxFitness = max;
  p->mini = min;
  p->maxi = max;
  return;
}

