
#include <stdlib.h>

#ifdef USE_PVM
#include <pvm3.h>
#endif /* USE_PVM */

#include "petrol.h"
#include "utils.h"


void Crossover(Population *p, Individual *p1, Individual *p2, Individual *c1,
	       Individual *c2) {

  int i, icross;

  if (flip(p->probCrossover)) {
    icross = randInt(0, p->chromosomeLen - 1);
    p->numCrossovers++;
  } else {
    icross = p->chromosomeLen;
  }

  for (i = 0; i < icross; i++) {
    c1->chrom[i] = Mutation(p, p1->chrom[i]);
    c2->chrom[i] = Mutation(p, p2->chrom[i]);
  }

  for (i = icross; i < p->chromosomeLen; i++) {
    c1->chrom[i] = Mutation(p, p2->chrom[i]);
    c2->chrom[i] = Mutation(p, p1->chrom[i]);
  }

}

int Mutation(Population *p, ChromType x) {
  if (flip(p->probMutation)) {
    p->numMutations++;
    return !x;
  } else {
    return x;
  }
}
